// Garden Gnome Software - Skin
// Pano2VR 5.2 beta4/15937
// Filename: skin.ggsk
// Generated Mon Jun 12 19:53:38 2017

function pano2vrSkin(player,base) {
	var ggSkinVars = [];
	var me=this;
	var flag=false;
	this.player=player;
	this.player.skinObj=this;
	this.divSkin=player.divSkin;
	this.ggUserdata=me.player.userdata;
	this.lastSize={ w: -1,h: -1 };
	var basePath="";
	// auto detect base path
	if (base=='?') {
		var scripts = document.getElementsByTagName('script');
		for(var i=0;i<scripts.length;i++) {
			var src=scripts[i].src;
			if (src.indexOf('skin.js')>=0) {
				var p=src.lastIndexOf('/');
				if (p>=0) {
					basePath=src.substr(0,p+1);
				}
			}
		}
	} else
	if (base) {
		basePath=base;
	}
	this.elementMouseDown=[];
	this.elementMouseOver=[];
	var cssPrefix='';
	var domTransition='transition';
	var domTransform='transform';
	var prefixes='Webkit,Moz,O,ms,Ms'.split(',');
	var i;
	if (typeof document.body.style['transform'] == 'undefined') {
		for(var i=0;i<prefixes.length;i++) {
			if (typeof document.body.style[prefixes[i] + 'Transform'] !== 'undefined') {
				cssPrefix='-' + prefixes[i].toLowerCase() + '-';
				domTransition=prefixes[i] + 'Transition';
				domTransform=prefixes[i] + 'Transform';
			}
		}
	}
	
	this.player.setMargins(0,0,0,0);
	
	this.updateSize=function(startElement) {
		var stack=[];
		stack.push(startElement);
		while(stack.length>0) {
			var e=stack.pop();
			if (e.ggUpdatePosition) {
				e.ggUpdatePosition();
			}
			if (e.hasChildNodes()) {
				for(var i=0;i<e.childNodes.length;i++) {
					stack.push(e.childNodes[i]);
				}
			}
		}
	}
	
	parameterToTransform=function(p) {
		var hs='translate(' + p.rx + 'px,' + p.ry + 'px) rotate(' + p.a + 'deg) scale(' + p.sx + ',' + p.sy + ')';
		return hs;
	}
	
	this.findElements=function(id,regex) {
		var r=[];
		var stack=[];
		var pat=new RegExp(id,'');
		stack.push(me.divSkin);
		while(stack.length>0) {
			var e=stack.pop();
			if (regex) {
				if (pat.test(e.ggId)) r.push(e);
			} else {
				if (e.ggId==id) r.push(e);
			}
			if (e.hasChildNodes()) {
				for(var i=0;i<e.childNodes.length;i++) {
					stack.push(e.childNodes[i]);
				}
			}
		}
		return r;
	}
	
	this.addSkin=function() {
		var hs='';
		this.ggCurrentTime=new Date().getTime();
		this._hiding_title_timer=document.createElement('div');
		this._hiding_title_timer.ggTimestamp=this.ggCurrentTime;
		this._hiding_title_timer.ggLastIsActive=true;
		this._hiding_title_timer.ggTimeout=4000;
		this._hiding_title_timer.ggId="hiding title timer";
		this._hiding_title_timer.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._hiding_title_timer.ggVisible=true;
		this._hiding_title_timer.className='ggskin ggskin_timer ';
		this._hiding_title_timer.ggType='timer';
		hs ='';
		hs+='height : 47px;';
		hs+='left : 12px;';
		hs+='position : absolute;';
		hs+='top : 13px;';
		hs+='visibility : inherit;';
		hs+='width : 139px;';
		hs+='pointer-events:none;';
		this._hiding_title_timer.setAttribute('style',hs);
		this._hiding_title_timer.style[domTransform + 'Origin']='50% 50%';
		me._hiding_title_timer.ggIsActive=function() {
			return (me._hiding_title_timer.ggTimestamp + me._hiding_title_timer.ggTimeout) >= me.ggCurrentTime;
		}
		me._hiding_title_timer.ggElementNodeId=function() {
			return me.player.getCurrentNode();
		}
		this._hiding_title_timer.ggActivate=function () {
			if (me.player.transitionsDisabled) {
				me._hiding_title_timer.style[domTransition]='none';
			} else {
				me._hiding_title_timer.style[domTransition]='all 1000ms ease-out 0ms';
			}
			me._hiding_title_timer.ggParameter.rx=0;me._hiding_title_timer.ggParameter.ry=0;
			me._hiding_title_timer.style[domTransform]=parameterToTransform(me._hiding_title_timer.ggParameter);
		}
		this._hiding_title_timer.ggDeactivate=function () {
			if (me.player.transitionsDisabled) {
				me._hiding_title_timer.style[domTransition]='none';
			} else {
				me._hiding_title_timer.style[domTransition]='all 1000ms ease-out 0ms';
			}
			me._hiding_title_timer.ggParameter.rx=0;me._hiding_title_timer.ggParameter.ry=-70;
			me._hiding_title_timer.style[domTransform]=parameterToTransform(me._hiding_title_timer.ggParameter);
		}
		this._hiding_title_timer.ggUpdatePosition=function (useTransition) {
		}
		this._hiding_title_text_box=document.createElement('div');
		this._hiding_title_text_box__text=document.createElement('div');
		this._hiding_title_text_box.className='ggskin ggskin_textdiv';
		this._hiding_title_text_box.ggTextDiv=this._hiding_title_text_box__text;
		this._hiding_title_text_box.ggId="hiding title text box";
		this._hiding_title_text_box.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._hiding_title_text_box.ggVisible=true;
		this._hiding_title_text_box.className='ggskin ggskin_text ';
		this._hiding_title_text_box.ggType='text';
		hs ='';
		hs+='height : 41px;';
		hs+='left : -3px;';
		hs+='position : absolute;';
		hs+='top : -4px;';
		hs+='visibility : inherit;';
		hs+='width : 128px;';
		hs+='pointer-events:auto;';
		this._hiding_title_text_box.setAttribute('style',hs);
		this._hiding_title_text_box.style[domTransform + 'Origin']='50% 50%';
		hs ='position:absolute;';
		hs+='cursor: default;';
		hs+='left: 0px;';
		hs+='top:  0px;';
		hs+='width: 128px;';
		hs+='height: 41px;';
		hs+='background: #ffffff;';
		hs+='border: 3px solid #000000;';
		hs+='border-radius: 15px;';
		hs+=cssPrefix + 'border-radius: 15px;';
		hs+='color: #000000;';
		hs+='text-align: center;';
		hs+='white-space: nowrap;';
		hs+='padding: 5px 6px 5px 6px;';
		hs+='overflow: hidden;';
		this._hiding_title_text_box__text.setAttribute('style',hs);
		this._hiding_title_text_box.ggUpdateText=function() {
			var hs=me.ggUserdata.title;
			if (hs!=this.ggText) {
				this.ggText=hs;
				this.ggTextDiv.innerHTML=hs;
				if (this.ggUpdatePosition) this.ggUpdatePosition();
			}
		}
		me._hiding_title_text_box.ggUpdateText();
		this._hiding_title_text_box.appendChild(this._hiding_title_text_box__text);
		me._hiding_title_text_box.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._hiding_title_text_box.ggElementNodeId=function() {
			if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
				return this.parentNode.ggElementNodeId();
			}
			return me.player.getCurrentNode();
		}
		this._hiding_title_text_box.ggUpdatePosition=function (useTransition) {
		}
		this._hiding_title_timer.appendChild(this._hiding_title_text_box);
		this.divSkin.appendChild(this._hiding_title_timer);
		this.divSkin.ggUpdateSize=function(w,h) {
			me.updateSize(me.divSkin);
		}
		this.divSkin.ggViewerInit=function() {
		}
		this.divSkin.ggLoaded=function() {
		}
		this.divSkin.ggReLoaded=function() {
		}
		this.divSkin.ggLoadedLevels=function() {
		}
		this.divSkin.ggReLoadedLevels=function() {
		}
		this.divSkin.ggEnterFullscreen=function() {
		}
		this.divSkin.ggExitFullscreen=function() {
		}
		this.skinTimerEvent();
	};
	this.hotspotProxyClick=function(id) {
	}
	this.hotspotProxyOver=function(id) {
	}
	this.hotspotProxyOut=function(id) {
	}
	this.changeActiveNode=function(id) {
		me.ggUserdata=me.player.userdata;
	}
	this.skinTimerEvent=function() {
		setTimeout(function() { me.skinTimerEvent(); }, 10);
		me.ggCurrentTime=new Date().getTime();
		if (me._hiding_title_timer.ggLastIsActive!=me._hiding_title_timer.ggIsActive()) {
			me._hiding_title_timer.ggLastIsActive=me._hiding_title_timer.ggIsActive();
			if (me._hiding_title_timer.ggLastIsActive) {
				if (me.player.transitionsDisabled) {
					me._hiding_title_timer.style[domTransition]='none';
				} else {
					me._hiding_title_timer.style[domTransition]='all 1000ms ease-out 0ms';
				}
				me._hiding_title_timer.ggParameter.rx=0;me._hiding_title_timer.ggParameter.ry=0;
				me._hiding_title_timer.style[domTransform]=parameterToTransform(me._hiding_title_timer.ggParameter);
			} else {
				if (me.player.transitionsDisabled) {
					me._hiding_title_timer.style[domTransition]='none';
				} else {
					me._hiding_title_timer.style[domTransition]='all 1000ms ease-out 0ms';
				}
				me._hiding_title_timer.ggParameter.rx=0;me._hiding_title_timer.ggParameter.ry=-70;
				me._hiding_title_timer.style[domTransform]=parameterToTransform(me._hiding_title_timer.ggParameter);
			}
		}
		me._hiding_title_text_box.ggUpdateText();
	};
	function SkinHotspotClass(skinObj,hotspot) {
		var me=this;
		var flag=false;
		this.player=skinObj.player;
		this.skin=skinObj;
		this.hotspot=hotspot;
		var nodeId=String(hotspot.url);
		nodeId=(nodeId.charAt(0)=='{')?nodeId.substr(1, nodeId.length - 2):'';
		this.ggUserdata=this.skin.player.getNodeUserdata(nodeId);
		this.elementMouseDown=[];
		this.elementMouseOver=[];
		
		this.findElements=function(id,regex) {
			return me.skin.findElements(id,regex);
		}
		
		{
			this.__div=document.createElement('div');
			this.__div.ggId="hotspot template";
			this.__div.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
			this.__div.ggVisible=true;
			this.__div.className='ggskin ggskin_hotspot ';
			this.__div.ggType='hotspot';
			hs ='';
			hs+='height : 5px;';
			hs+='left : 357px;';
			hs+='position : absolute;';
			hs+='top : 134px;';
			hs+='visibility : inherit;';
			hs+='width : 5px;';
			hs+='pointer-events:auto;';
			this.__div.setAttribute('style',hs);
			this.__div.style[domTransform + 'Origin']='50% 50%';
			me.__div.ggIsActive=function() {
				return me.player.getCurrentNode()==this.ggElementNodeId();
			}
			me.__div.ggElementNodeId=function() {
				return me.hotspot.url.substr(1, me.hotspot.url.length - 2);
			}
			this.__div.onclick=function (e) {
				me.player.openNext(me.hotspot.url,me.hotspot.target);
				me.skin._hiding_title_timer.ggTimeout=Number("4") * 1000.0;
				me.skin._hiding_title_timer.ggTimestamp=me.skin.ggCurrentTime;
				me.skin.hotspotProxyClick(me.hotspot.id);
			}
			this.__div.onmouseover=function (e) {
				me.player.setActiveHotspot(me.hotspot);
				me.skin.hotspotProxyOver(me.hotspot.id);
			}
			this.__div.onmouseout=function (e) {
				me.player.setActiveHotspot(null);
				me.skin.hotspotProxyOut(me.hotspot.id);
			}
			this.__div.ggUpdatePosition=function (useTransition) {
			}
			this._hotspot_image=document.createElement('div');
			this._hotspot_image.ggId="hotspot image";
			this._hotspot_image.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
			this._hotspot_image.ggVisible=true;
			this._hotspot_image.className='ggskin ggskin_rectangle ';
			this._hotspot_image.ggType='rectangle';
			hs ='';
			hs+=cssPrefix + 'border-radius : 999px;';
			hs+='border-radius : 999px;';
			hs+='background : #ff0000;';
			hs+='border : 1px solid #000000;';
			hs+='cursor : default;';
			hs+='height : 22px;';
			hs+='left : -11px;';
			hs+='position : absolute;';
			hs+='top : -11px;';
			hs+='visibility : inherit;';
			hs+='width : 22px;';
			hs+='pointer-events:auto;';
			this._hotspot_image.setAttribute('style',hs);
			this._hotspot_image.style[domTransform + 'Origin']='50% 50%';
			me._hotspot_image.ggIsActive=function() {
				if ((this.parentNode) && (this.parentNode.ggIsActive)) {
					return this.parentNode.ggIsActive();
				}
				return false;
			}
			me._hotspot_image.ggElementNodeId=function() {
				if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
					return this.parentNode.ggElementNodeId();
				}
				return me.ggNodeId;
			}
			this._hotspot_image.ggUpdatePosition=function (useTransition) {
			}
			this.__div.appendChild(this._hotspot_image);
		}
	};
	this.addSkinHotspot=function(hotspot) {
		return new SkinHotspotClass(me,hotspot);
	}
	this.addSkin();
};